# *-*-perl-*-*
eval 'exec perl -Ssw $0 "$@"'
    if 0;
#
#!/usr/bin/perl -sw
#
# dump_cyc_assertions.perl: dump out all the assertions for a list of Cyc terms,
# optionally to separate files for each term
# 
# Portions Copyright (c) 2001 Cycorp, Inc.  All rights reserved.
#
# NOTES:
#
# - lynx -dump -nolist -width=512 "http://localhost:3622/cgi-bin/cyccgi/cg?cb-c-total&deviceUsed" >| deviceUsed.data
#


# Load in the common module, making sure the script dir is first in Perl's lib path
BEGIN { my $dir = `dirname $0`; chomp $dir; unshift(@INC, $dir); }
require 'common.perl';
require 'NL_support.perl';

# Process the command-line options
if (!defined($ARGV[0])) {
    my($options) = "options = [-separate]";
    my($example) = "examples:\n\n$script_name - < ActorSlot.instances\n\n";
    my($note) = "";

    die "\nusage: $script_name [options] mt-listing ...\n\n$options\n\n$example\n$note\n";
}


&init_var(*separate, &FALSE);	# separate the output into files
&init_var(*port, 0);		# port offset
&init_var(*host, "localhost");	# host name
&init_var(*width, 512);		# line width for lynx dump

$port += 3601 if ($port < 100);
my($port_spec) = ($port == 3601) ? "$host" : sprintf "$host:%d", $port + 1;

# Init TCP access to Cyc server and load in supporting lisp code if necessary
&init_NL_support();

my(@term_list) = ($ARGV[0] eq "-") ? <STDIN> : @ARGV;
&debug_out(&TL_VERBOSE, "terms=(@term_list)\n");

foreach my $term (@term_list) {
    chomp $term;
    
    my($data) = &run_command("lynx -dump -nolist -width=$width 'http://${port_spec}/cgi-bin/cyccgi/cg?cb-c-total&$term'");

    if ($separate) {
	&write_file("$term.data", $data);
    }
    else {
	print $data;
	print "\n";
    }
}

&exit();

#------------------------------------------------------------------------

