# *-*-perl-*-*
eval 'exec perl -Ssw $0 "$@"'
    if 0;
#!/usr/local/bin/perl -sw
#
# intersection.perl: show the word overlap (or difference) of two files
# TODO: add options for non-overlap since difference is directional
#

# Load in the common module, making sure the script dir is in the Perl lib path
BEGIN { my $dir = `dirname $0`; chomp $dir; unshift(@INC, $dir); }
require 'common.perl';

&init_var(*diff, &FALSE);	# use set difference instead of intersection
&init_var(*do_diff, $diff);	# alias for -diff
&init_var(*line, &FALSE);	# do line-level intersection (not word)
&init_var(*single_line, &FALSE); # use single-line for output

# Do some sanity checks
if (&DEBUG_LEVEL >= &TL_VERBOSE) {
    local(@l1) = ("a", "b", "c");
    local(@l2) = ("b");
    debug_out(4, "diff(l1, l2) = %s\n", &new_difference(*l1, *l2));
    debug_out(4, "int(l1, l2) = %s\n", &new_intersection(*l1, *l2));
}

# Determine which set function to use
*set_operation = ($do_diff ? *new_difference : *new_intersection);

# Check the command-line for the names of the two files
#
if (!defined($ARGV[1])) {
    die "usage: $0 [-diff] [-line] file1 file2\n";
}
my($file1) = shift @ARGV;
my($file2) = shift @ARGV;


# Read in the files, and determine their intersecton (difference)
#
local(@file1) = ($line ? &get_file_lines($file1) : &get_file_words($file1));
&trace_array(\@file1);
local(@file2) = ($line ? &get_file_lines($file2) : &get_file_words($file2));
&trace_array(\@file2);
local(@file3) = &set_operation(*file1, *file2);

# Display the results of the intersection
#
my($delim) = $single_line ? " " : "\n";
&debug_print(&TL_DETAILED, "*set_operation($file1, $file2):\n");
printf "%s\n", join($delim, @file3);


#------------------------------------------------------------------------------

# get_file_words(file-name): returns list of word tokens from the file
# note: this converts the tokens to lowercase
#
sub get_file_words {
    local($file) = @_;
    local($text) = &read_file($file);

    $text =~ tr/A-Z/a-z/;

    return (&tokenize($text));
}

# get_file_lines(file-name): returns list of lines from the file
#
sub get_file_lines {
    local($file) = @_;
    local($text) = &read_file($file);

    return (split(/\n/, $text));
}
